import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class nothing_left extends PApplet {

/* @pjs font="OpenSans-Bold.ttf"; */
/* @pjs font="OpenSans-Italic.ttf"; */

//import java.util.Iterator;

float lower_limit = 840; // lower bound of the screen, plus a margin
int player_size = 13;
int shield_size = 45;
int enemy_size = 15;
int max_health = 256;
int enemy_max_damage = 300;
int shield_strength = 1200;



class Enemy {
  PVector spawn_position;
  PVector position;
  PVector calculated_velocity;
  ArrayList<Gun> guns;
  boolean alive = true; 
  int damage = 0;
  int movement_mode = 0;

  float vspeed = 0.2f;
  float sine_amp = 50.0f;
  float sine_frequency = 60;

  public void update() {
    PVector last_position = new PVector(position.x, position.y);
    switch(movement_mode) {
      case 0:
        position.add(new PVector(0, 0.5f));
        break;
      case 1:
        position.add(new PVector(0, vspeed));
        break;
      case 3:
        position.add(new PVector(0, vspeed));
        position.x = spawn_position.x;//lerp(spawn_position.x - sine_amp, spawn_position.x + sine_amp, sin(time.get_time() / sine_frequency));
        position.x = position.x + lerp(0 - (sine_amp / 2), (sine_amp / 2), sin(time.get_time() / TWO_PI * sine_frequency));
      case 4:
        position.add(new PVector(0, vspeed));
        position.x = lerp(spawn_position.x - sine_amp, spawn_position.x + sine_amp, sin(time.get_time() / sine_frequency));
        position.x = position.x + lerp(0 - sine_amp, sine_amp, sin(time.get_time() / TWO_PI * sine_frequency));
      default:
        position.add(new PVector(0, vspeed));
        position.x = lerp(spawn_position.x - sine_amp, spawn_position.x + sine_amp, sin(time.get_time() / sine_frequency));
        break;
    }
    calculated_velocity = PVector.sub(position, last_position);
    //print("\n" + calculated_velocity);
    
    for (Gun g : guns) {
      g.update(position);
      g.setParentVelocity(calculated_velocity);
    }
    if (position.y > lower_limit) { // too far offscreen
      alive = false;
      score.level();
    }
    if(damage > 0)
    {
      damage = damage - 1;
      if (damage > enemy_max_damage) {
        alive = false;
        score.level();
        score.increase(100);
      }
    }
 
  }
  
  //PVector getVelocity() {
    //return new PVector(calculated_velociy.x, calculated_velocity.y);
  //}

  public void display() {
    fill(240, 200, 15);
    rect(position.x, position.y, enemy_size, enemy_size);
    if(damage > 0) {
      fill(255,0,0, lerp(20, 255, ((float)damage / (float)enemy_max_damage)));
      rect(position.x, position.y, enemy_size, enemy_size);
    }
    fill(0, 0, 0);
    for (Gun g : guns) {
      g.display();
    }
  }
  
  public void hit() {
    damage = damage + 175;
    
  }

  Enemy() {
    spawn_position = new PVector(200, -40);
    position = new PVector(200, -40);
    calculated_velocity = new PVector(0, 0);
    guns = new ArrayList<Gun>();
    guns.add(new Gun());
    guns.add(new Gun());
    guns.add(new Gun());
    damage = 0;
  }
  Enemy(float location, int mov_mode, float hrz, int gun_count, int firing_speed, int firing_pattern, boolean lockstep, boolean moment) {
    calculated_velocity = new PVector(0, 0);
    spawn_position = new PVector(location, -40);
    position = new PVector(spawn_position.x, spawn_position.y);
    vspeed = lerp(2, 0.2f, max(min(((float)difficulty / 25) * random(0.0f, 1.0f), 1), 0));
    sine_amp = lerp(20.0f, 70.0f, hrz);
    sine_frequency = lerp(40, 200, hrz);
    switch(mov_mode) {
      case 0:
        movement_mode = 1;
      break;
      case 1:
        movement_mode = 2;
        break;
      case 2: 
        movement_mode = 3;
        break;
      case 3:
        movement_mode = 4;
        break;
      default:
        movement_mode = 2;
        break;
    }
    //movement_mode = 4;
    //float turret_rotation = 
    guns = new ArrayList<Gun>();
    for(int i = gun_count; i >= 0; i--) {
      Gun g = new Gun(firing_speed, firing_pattern, moment);
      if(lockstep) {
        g.setRotationSpeed(6000 + lerp(0, 42000, max(min((float)difficulty,10),0) * random(0.0f, 1.0f)));
      }      
      guns.add(g);      
    }  
  }
}

class Gun {
  PVector parent_pos;
  PVector offset;
  int firing_delay;
  float rotation_speed;
  int last_shot;
  int next_shot;
  int firing_pattern = 0;
  boolean use_parent_velocity;
  PVector parent_velocity;

  public void setParentVelocity(PVector p) {
    parent_velocity = new PVector(p.x, p.y);
  }
  
  public void display() {
    PVector current_pos = PoseGun();
    rect(current_pos.x, current_pos.y, 7, 7);
  }

  public PVector PoseGun() {
    PVector current_pos = new PVector(offset.x, offset.y);
    rotate2D(current_pos, lerp(0, 360, (time.get_time() % rotation_speed) / rotation_speed));
    //current_pos.rotate(lerp(0, 360, (time.get_time() % rotation_speed) / rotation_speed)); // Not in Processing.js yet
    current_pos.add(parent_pos);
    return current_pos;
  }

  public void update(PVector p) {
    parent_pos = new PVector(p.x, p.y);
    if (time_to_shoot()) { 
      shoot();
    }
  }

  public boolean time_to_shoot() {
    // check time, should we shoot?
    if (time.get_time() > last_shot + next_shot) {
      return true;
    }
    return false;
  }

  public void shoot() {
    PVector vel = new PVector();
    vel = PVector.sub(PoseGun(), parent_pos);

    vel.normalize();
    float bullet_speed = 1.0f;
    vel.mult(bullet_speed); // setMag not in .js yet

    //vel.setMag(1);
    last_shot = time.get_time();
    switch(firing_pattern) {
      case 0:
        next_shot = firing_delay / 10;
        break;
      case 1:
        next_shot = firing_delay / 20;
        if(random(0.0f, 1.0f) < 0.1f) {
          next_shot = firing_delay;
        }
        break;
      case 3:
        vel.mult(random(0.5f, 3.0f));
        next_shot = firing_delay / 4;
        break;
      default:
        next_shot = (int)(time.get_time() % (float)firing_delay);//(sin((time.get_time() % firing_delay) * TWO_PI));
        break;
    }
    if(use_parent_velocity) {
      vel.add(parent_velocity);
    }
    bullet_list.add(new Bullet(PoseGun(), vel));
    //print (next_shot);
    //print(",");
  }

  public void setRotationSpeed(float speed) {
    rotation_speed = speed;
  }

  Gun() {
    parent_pos = new PVector();
    offset = new PVector();
    offset = new PVector(random(-20.0f, 20.0f), random(-20.0f,20.0f));
    offset.normalize();
    offset.mult(20);
    //offset.setMag(20); // setMag not in .js yet
    firing_delay = 120;
    rotation_speed = 18000;//random(6000, 40000);
    last_shot = 0;
    next_shot = 0;
    parent_velocity = new PVector();
    use_parent_velocity = true;
  }
  Gun(int speed, int pattern, boolean use_velocity) {
    parent_velocity = new PVector();
    use_parent_velocity = use_velocity;
    parent_pos = new PVector();
    offset = new PVector();
    offset = new PVector(random(-20.0f, 20.0f), random(-20.0f,20.0f));
    offset.normalize();
    offset.mult(20);
    //offset.setMag(20); // setMag not in .js yet
    firing_delay = speed;
    rotation_speed = 6000 + lerp(0, 42000, max(min((float)difficulty,10),0) * random(0.0f, 1.0f));
    last_shot = 0;
    next_shot = 0;
    firing_pattern = pattern;
    //firing_pattern = 3;
  }
}

class Bullet {
  PVector position;
  PVector velocity;
  boolean alive;
  public void update() {
    position.add(velocity);
    //kill if out of bounds...
    if (position.x < 0 || position.x > 400 || position.y < 0 || position.y > 800) {
      alive = false;
      score.increase();
    }
  }
  public void display() {
    rect(position.x, position.y, 3, 3);
  }
  public boolean collision(PVector p, float size) {
    //if (PVector.dist(p, position) < radius) {
    if(withinBoundingBox(position, p, new PVector(size, size))) {
      alive = false;
      score.increase();
      return true;
    }
    return false;
  }
  Bullet(PVector pos, PVector vel) {
    position = pos;
    velocity = vel;
    alive = true;
  }
  Bullet(Bullet b) { 
    // create a reverse bullet
    position = new PVector(b.position.x, b.position.y);
    velocity = new PVector(-b.velocity.x, -b.velocity.y);
    //rotate2D(velocity, 180);
    alive = true;    
  }
}

class Powerup {
  PVector position;
  PVector velocity;
  boolean alive = true;

  public void update () {
    position.add(velocity);
  }

  public void display() {
    fill(45, 45, 180);
    if(!alive) {
      stroke(0,255,255,50);
    }
    rect(position.x, position.y, 7, 7);
  }

  public boolean collision(PVector p, float size) {
    //if (PVector.dist(p, position) < radius) {
    if(withinBoundingBox(position, p, new PVector(size, size))) {
      alive = false;
      score.increase(20);
      next_powerup = next_powerup + 60;

      return true;
    }
    return false;
  }

  Powerup() {
    position = new PVector(random(10, 390), -30);
    velocity = new PVector(0, random(1,2) + lerp(0, 1.5f, min(1.0f,((float)difficulty) / 75)));
    alive = true;
  }
}

class Player {
  PVector position;
  int damage = 0;
  float player_shield = 0;

  public void update() {
    PVector target = new PVector(mouseX, mouseY);
    PVector delta = PVector.sub(target, position);
    delta.limit(100.0f);
    float mag = delta.mag();
    //PVector alt_delta = new PVector(delta.x, delta.y);
    //alt_delta.setMag(easeOutQuad(mag, 0, 5, 100.0)); // setMag not in .js yet
    delta.normalize();
    delta.mult(easeOutQuad(mag, 0, 5, 100.0f));
    //print("\n:" + delta.mag() + "\t: " + alt_delta.mag() + "\t:" + (delta.mag() - alt_delta.mag()));
    
    position.add(delta);
    if (damage > 0) {
      damage = damage - 1;
    }
    float nearest = distance_to_nearest_enemy();
    if(nearest > 100) { nearest = 100.0f; }
    if(player_shield > 0) {
      float depreciate = lerp(30, 0.7f, easeOutQuad(nearest, 0.0f, 1.0f, 100.0f));
      player_shield = player_shield - depreciate;//round(depreciate);
    }
    if(player_shield < 0) { player_shield = 0; }
  }
  
  public void hit_shield() {
    if(player_shield > 0) {
      //float depreciate = lerp(30, 1, easeOutQuad(nearest, 0.0, 1.0, 100.0));
      player_shield = player_shield - 1;//round(depreciate);
    }
    if(player_shield < 0) { player_shield = 0; }
  }

  public void display() {
    fill(45, 180, 42);
    rect(position.x, position.y, player_size, player_size);

    if (damage > 0) {
      //fill(180, 0, 0, min(255, 128 * (damage / 100)));
      //rect(position.x, position.y, 15, 15);
    }
    if(player_shield > 0) {
      fill(0, 45, 200, lerp(20, 200, min(255, (float)player_shield / shield_strength)));
      rect(position.x, position.y, shield_size, shield_size);
    }
  }
  public void hit () {
    if (player_shield <= 0) {
      damage = damage + 150;
      if (damage > max_health) { 
        damage = max_health; 
        reset();
      }
    }
  }
  
  public void shield() {
    player_shield = shield_strength;
  }

  Player() {
    position = new PVector(200, 700);
    player_shield = 0;
  }
}

public boolean withinBoundingBox(PVector point, PVector box_center, PVector box_size) {
  // Test to see if point is within AABB defined by a center and size
  if(((box_center.x - ((float)box_size.x / 2)) < point.x) && (point.x < (box_center.x + ((float)box_size.x / 2)))) {
    if(((box_center.y - ((float)box_size.y / 2)) < point.y) && (point.y < (box_center.y + ((float)box_size.y / 2)))) {
      return true;
    }
  }
  return false;
}

// From http://www.shiffman.net/2011/02/03/rotate-a-vector-processing-js/
public void rotate2D(PVector v, float theta) {
  float xTemp = v.x;
  v.x = v.x*cos(theta) - v.y*sin(theta);
  v.y = xTemp*sin(theta) + v.y*cos(theta);
}

// From http://www.gizma.com/easing/#quad3
public float easeInOutQuad(float t, float b, float c, float d) {
  t /= d/2;
  if (t < 1) return c/2*t*t + b;
  t--;
  return -c/2 * (t*(t-2) - 1) + b;
};

// From http://www.gizma.com/easing/#quad2
public float easeOutQuad(float t, float b, float c, float d) {
  t /= d;
  return -c * t*(t-2) + b;
};

// From http://www.gizma.com/easing/#quad1
public float easeInQuad (float t, float b, float c, float d) {
  t /= d;
  return c*t*t + b;
};

class Time {
  int frames = 0;
  public int get_time() {
    return frameCount;
  }
  public void update() {
    frames = frames + 1;
  }
  Time() {
    frames = 0;
  }
}

class Score {
  int value;
  int count;
  int ecount;
  int wave;
  Score() {
    value = 0;
    count = 0;
    ecount = 0;
    wave = 1;
  }
  public void increase(int mult) {
    value = value + (difficulty * mult);
    count = count + 1;
    set_difficulty();
  }
  public void level() {
    ecount = ecount + 1;
    set_difficulty();
  }
  public void increase() {
    value = value + difficulty;
    //print("\n: "+ value);
    count = count + 1;
    set_difficulty();
  }
  public int get_score() { 
    return value;
  }
  public void set_difficulty() {
    int last_difficulty = floor(sqrt((float)difficulty));
    float cmax = max(min(((float)ecount), 80), 0);
    difficulty = (int)lerp(1, 200, (cmax / 80)); //(int)easeInQuad(cmax, 1, 200, 40); 
    if(floor(sqrt((float)difficulty)) != last_difficulty) {
      // mark the next wave
      // TODO: Display level name
      //print("\nLEVEL " + (floor(sqrt((float)difficulty))));
      //print("\nLevel: " + difficulty + " \tScore: " + count + " " + cmax);
      wave_label_fade = 255;
      current_wave = (floor(sqrt((float)difficulty)));
      next_spawn = next_spawn + 200;
    }
     
  }
}

int current_wave = 0;
float wave_label_fade = 0;
int difficulty;

ArrayList<Bullet> bullet_list;
ArrayList<Bullet> reverse_bullet_list;
ArrayList<Enemy> enemy_list;
ArrayList<Powerup> powerup_list;
Player player;
Time time;
Score score;
boolean game_active;

public void begin() {
  wave_label_fade = 0;
  current_wave = 0;
  bullet_list = new ArrayList<Bullet>();
  reverse_bullet_list = new ArrayList<Bullet>();
  enemy_list = new ArrayList<Enemy>();
  powerup_list = new ArrayList<Powerup>();
  player = new Player();
  score = new Score();
  time = new Time();
  last_spawn = -1000;//time.get_time();
  last_powerup = -1000;
  //next_spawn = 0;
  //SpawnOneEnemy();
  score.set_difficulty();
  game_active = true;
  quote_fade = 255;
}

public void reset() {
  begin();
}

//PFont font;

float quote_fade;
public void fadingQuote() {
    textAlign(CENTER, CENTER);
  textLeading(18);

  //String qu = "\"...perfection is finally attained\n not when there is no longer anything to add,\nbut when there is no longer anything to take away...\"\n--Antoine de Saint Exup\u00e9ry";
  fill(145, (int)quote_fade);
  text(qu, 200, 600);
  quote_fade = quote_fade - 0.7f;
}

public void display_score() {
  textFont(bold_small);
  fill(180);
  textAlign(RIGHT, TOP);
  String sc = "" + score.get_score();
  text(sc, 395, 5);
}


public void displayWave() {
  textFont(bold_big);
  textAlign(CENTER, CENTER);
  String wav = "LEVEL " + current_wave;
  fill(lerp(243,45, (wave_label_fade/255)));
  text(wav, 200, 300);  
  wave_label_fade -= 1;
}

PFont bold_small;
PFont bold_big;
PFont italic;
String qu;

public void setup() {
  size(400, 800);
  background(243, 243, 243);
  rectMode(CENTER);
  frameRate(60);
  smooth();
  bold_small = createFont("OpenSans-Bold.ttf", 14);
  bold_big = createFont("OpenSans-Bold.ttf", 24);
  italic = createFont("OpenSans-Italic.ttf", 15);
  textFont(italic);
  qu = "\"...perfection is finally attained\n not when there is no longer anything to add,\nbut when there is no longer anything to take away...\"\n--Antoine de Saint Exup\u00e9ry";
  float tw = textWidth(qu);
  fill(145);
  textAlign(CENTER, CENTER);
  textLeading(18);
  text(qu, 200, 600);
  
  textFont(createFont("OpenSans-Bold.ttf", 18));
  fill(105);
  String ctb = "Click Here to Focus";
  text(ctb, 200, 700);
  textFont(createFont("OpenSans-Bold.ttf", 14));
  fill(195);
  text("Ludum Dare #26\nby Isaac Karth", 200, 270);
  textFont(createFont("OpenSans-Bold.ttf", 36));
  fill(105);
  text("Nothing Left", 200, 200);
  
  game_active = false;
  wave_label_fade = 0;
  //begin();
}

public void mouseClicked() {
  if(!game_active) {
    begin();
  }
}

public void draw() {
  //rect(random(0, 400), random(0, 800), 5, 5);
  if(game_active) {

  //time.update();  
  update();
  collision();
  background(243, lerp(243, 128, ((float)player.damage / 200)), lerp(243, 128, ((float)player.damage / 200)));
    if(quote_fade > 0) {
      textFont(italic);
      fadingQuote();
    }
    display_score();
    if(wave_label_fade > 0) {
      displayWave();
    }
  player.display();

  for (Enemy e : enemy_list) {
    e.display();
  }
  for (Powerup p : powerup_list) {
    p.display();
  }

  // Bullets
  noStroke();
  fill(200, 45, 45);
  for (Bullet b : bullet_list) {
    b.display();
  }

  // Bounced Bullets
  fill(45, 45, 200);
  for (Bullet b : reverse_bullet_list) {
    b.display();
  }
  }
}

public float distance_to_nearest_enemy() {
  float dist = 100000.0f;
  for (Enemy e : enemy_list) {
    float dist_to = PVector.dist(player.position, e.position);
    if (dist_to < dist) { dist = dist_to; } 
  } 
  return dist;
}

public void update() {
  player.update();
  
  SpawnMoreEnemies();
  SpawnMorePowerups();
  
  for (Enemy e : enemy_list) {
    e.update();
  }
  for (Bullet b : bullet_list) {
    b.update();
  }
  for (Bullet b : reverse_bullet_list) {
    b.update();
  }
  for (Powerup p : powerup_list) {
    p.update();
  }
  
  // Can't use Java libs
  for (int i = bullet_list.size()-1; i >= 0; i--) {
    Bullet p = bullet_list.get(i);
    if(!p.alive) {
      bullet_list.remove(p);
    }
  }
  for (int i = reverse_bullet_list.size()-1; i >= 0; i--) {
    Bullet p = reverse_bullet_list.get(i);
    if(!p.alive) {
      reverse_bullet_list.remove(p);
    }
  }
  for (int i = powerup_list.size()-1; i >= 0; i--) {
    Powerup p = powerup_list.get(i);
    if(!p.alive) {
      powerup_list.remove(p);
    }
  }
  for (int i = enemy_list.size()-1; i >= 0; i--) {
    Enemy p = enemy_list.get(i);
    if(!p.alive) {
      enemy_list.remove(p);
    }
  }
  
  /*
  Iterator<Bullet> iter = bullet_list.iterator();
  while (iter.hasNext () ) {
    //iter.next().update();
    if (!iter.next().alive) {
      iter.remove();
    }
  }
  Iterator<Powerup> iterpow = powerup_list.iterator();
  while (iterpow.hasNext () ) {
    //iter.next().update();
    if (!iterpow.next().alive) {
      iterpow.remove();
    }
  }
  */
  

}

public void collision() {
  // player vs. powerup
  for (Powerup i : powerup_list) {
    if (i.collision(player.position, player_size + 2)) {
      player.shield();
    }
  }

  // bullets vs. reversing shield
  if (player.player_shield > 0) {
    for (Bullet b : bullet_list) {
      if (b.collision(player.position, shield_size)) { // 24 = shield size
        reverse_bullet_list.add(new Bullet(b)); //TODO
        player.hit_shield();
      }
    }
  }
  // bullets vs. player
  for (Bullet b : bullet_list) {
    if (b.collision(player.position, 9)) { // use a smaller hitbox than the actual player size
      player.hit();
    }
  }
  // reverse bullets vs. enemies
  for (Bullet b : reverse_bullet_list) {
    for(Enemy e : enemy_list) {
      if (b.collision(e.position, enemy_size + 4)) {
        e.hit();
      }
    }
  }
}

public void SpawnOneEnemy() {
  enemy_list.add(new Enemy());
}

int next_spawn = 1000;
int last_spawn = 0;
public void SpawnMoreEnemies() {
    
 if (time.get_time() > last_spawn + next_spawn) {
    //SpawnOneEnemy();
    SpawnShips();
    last_spawn = time.get_time();
    if(difficulty < 5) {
      next_spawn = 500;
      //next_spawn = round(lerp(700, 400, max(min(((float)(difficulty) / 5), 1.0), 0.0)));
    } else {
      next_spawn = round(lerp(400, 900, max(min(((float)(difficulty - 5) / 50), 1.0f), 0.0f)));
    }
  }
}

int next_powerup = 1000;
int last_powerup = 0;
public void SpawnPowerup() {
  powerup_list.add(new Powerup());
}

public void SpawnMorePowerups() {
  if(time.get_time() > last_powerup + next_powerup) {
    SpawnPowerup();
    last_powerup = time.get_time();
   }
}

// ---: Spawn enemies in waves
// TODO: More variations in enemy variables, gun motion, shooting speed...but clumped. Perlin noise?
// TODO: Add music
// TODO: Display Score
// TODO: Display Credits
// TODO: Display Intro Text
// ---: Powerup/Shield

// Things that can change with difficulty:
// * # of ships in wave
// * time between waves
// ship movement pattern - just dropping, sine wave, sine wave + another function, vertical wave
// # of guns on ship
// gun firing pattern
// gun firing rate
// time between powerups

public void SpawnShips() {
  //print("\n----------------\n");
  int difficulty_level = difficulty;
  // Randomly spike particular areas so they're more difficult
  int[] buckets = new int[5];
  for(int i = difficulty_level; i >= 0; i-- ) {
    int random_bucket = floor(noise(score.get_score() + random(0.0f,2.7f)) * 5.5f);
   // print("\t" + random_bucket);
    random_bucket = min(4, random_bucket);
    random_bucket = max(0, random_bucket);
    buckets[random_bucket] = buckets[random_bucket] + 1; 
  }
  //print("\n ");
  for(int i = 0; i <5; i++ ) {
    //print (" " + easeInQuad(max(min(i, 25), 0), 0, 5, 25));
    //print ("\t" + buckets[i]);
  }
  int spike_max_level = 25;
  int half_spike = 15;
  int base_number_of_ships = (int)easeInQuad(max(min(((float)difficulty_level * random(0.5f,1.0f)), half_spike),0), 1, 2, half_spike);
  int spike_number_of_ships = (int)easeInQuad(max(min((float)buckets[0], spike_max_level), 0), -1, 5, spike_max_level);
  spike_number_of_ships = (spike_number_of_ships >= 0) ? spike_number_of_ships : 0; 
  int movement_difficulty = (int)easeInQuad(max(min(((float)buckets[1]) * random(0.0f, 1.0f), half_spike), 0), 0, 3, half_spike);
  int num_of_guns = (int)easeInQuad(max(min((float)buckets[2] * random(0.0f, 1.0f), spike_max_level), 0), 1, 12, spike_max_level);
  int firing_speed = (int)easeInQuad(max(min(((float)buckets[3] * random(0.0f, 1.0f)), spike_max_level), 0), 180, 45, spike_max_level);
  int firing_pattern = (int)easeInQuad(max(min(((float)buckets[4]) * random(0.0f, 1.0f), half_spike), 0), 0, 3, half_spike);  
  int number_of_ships = (base_number_of_ships + spike_number_of_ships);
  float spawn_center = 100 + random(0, 200);
  float spawn_spread = random(number_of_ships * 20, 100);
  float shimmy = max(min(((float)difficulty_level / spike_max_level) * random(0.0f, 1.0f), 1.0f), 0.0f);
  boolean lockstep = false;
  boolean momentum = false;
  if((random(0.0f, 1.0f) > 0.3f)) {
    momentum = true;
  }
  if((random(0.0f, 1.0f) > 0.3f)) {
    lockstep = true;
  }
  //print("\n" + shimmy);
  for(int spwn = 0; spwn < number_of_ships; spwn++) {
    enemy_list.add(new Enemy(
      random(20, 380),//lerp((spawn_center - spawn_spread), (spawn_center + spawn_spread), spwn), 
      movement_difficulty, shimmy, num_of_guns, firing_speed, firing_pattern, lockstep, momentum));
  }
}


  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "nothing_left" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
